import 'package:flutter/material.dart';

import 'TextureController.dart';

/*
 * @auther YuanShuai
 * @created at 2020/5/11 23:32
 * @desc 外接纹理控件
 */
class ExTextureWidget extends StatefulWidget {
  final double width;
  final double height;
  final String channelName;
  final bool asGif;
  final String img;

  const ExTextureWidget(
      {Key key,
      this.img,
      this.channelName,
      this.width = 0,
      this.height = 0,
      this.asGif = false})
      : assert(img != null),
        super(key: key);

  @override
  State<StatefulWidget> createState() => _ExTextureWidget();
}

class _ExTextureWidget extends State<ExTextureWidget> {
  final _controller = TextureController();

  @override
  void initState() {
    super.initState();
    initializeController();
  }

  @override
  void dispose() {
    super.dispose();
    _controller.dispose();
  }

  Future<Null> initializeController() async {
    await _controller.initialize(widget.img,widget.asGif,widget.width, widget.height);
    setState(() {
    });
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      width:
          widget.width <= 0 ? MediaQuery.of(context).size.width : widget.width,
      height: widget.height <= 0
          ? MediaQuery.of(context).size.height
          : widget.height,
      child: _controller.isInitialized
          ? Texture(textureId: _controller.textureId)
          : null,
    );
  }
}
